Aurigma Customer's Canvas SDK - Design Atoms Framework
============================================

[**Customer's Canvas**](https://customerscanvas.com) is a software development kit (SDK) to develop personalized products for the printing industry.
This SDK includes the **Design Atoms framework** allowing you to both create product designs from scratch and work with the Customer's Canvas object model.

## The Package

This package represents the back end of the **Design Atoms framework**. To deploy the front end, you can install the [@aurigma/design-atoms](https://www.npmjs.com/package/@aurigma/design-atoms) package through `npm`.

This back end supports the Server API for the Design Viewer. You can also develop custom methods to preview and generate high-resolution outputs.

## Running the Back End

1. Create an **ASP.NET Web Application (.NET Framework)** project. When creating the project, use the **Web API** project template.
2. Install **Aurigma.DesignAtoms** through the NuGet Package Manager.
3. Register [your license key](https://customerscanvas.com/docs/cc/registering-production-license-keys.htm).
4. In the **Global.asax.cs** file:
	- At the beginning of **Application_Start**, add `Aurigma.DesignAtoms.Configuration.Configuration.Setup(enableCors: true);`
	- At the end of **Application_Start**, add `Aurigma.DesignAtoms.Licensing.Check();`
5. In the **WebApiConfig.cs** file, remove `config.MapHttpAttributeRoutes();`
6. Start your application.

## Configuration

To configure your server, use parameters described in the [documentation](https://customerscanvas.com/docs/cc/web-config.htm).

## Code Samples

You can download a sample backend implementation from [GitHub](https://github.com/aurigma/DesignAtomsSamples).

## Documentation

You can refer to the [Customer's Canvas docs](https://customerscanvas.com/docs/cc/getting-started.htm)
